function y = findS(Sx,K,r,q,v,T,phi);

% Returns the threshold S*

% Inline function for the Black Scholes call
C = inline('s*exp(-q*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T)) - K*exp(-r*T)*normcdf((log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) - v*sqrt(T))',...
	's','K','r','q','v','T');

% Inline function for the Black Scholes put
P = inline('K*exp(-r*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T) + v*sqrt(T)) - s*exp(-q*T)*normcdf(-(log(s/K) + (r-q+v^2/2)*T)/v/sqrt(T))',...
	's','K','r','q','v','T');

% If Sx <= 0 impose a penalty.
if Sx <= 0
	y = 1e100;
else	
	d1 = (log(Sx/K) + (r-q+v^2/2)*T)/v/sqrt(T);
	if ~isreal(d1) | isinf(d1) | Sx <= 0;
		y = 1e100;
	else
		if phi == 1               % Calls
			Ve = C(Sx,K,r,q,v,T);
		elseif phi == -1          % Puts
			Ve = P(Sx,K,r,q,v,T);
		end
		h = 1 - exp(-r*T);
		beta = 2*(r-q)/v^2;
		alpha = 2*r/v^2;
		if r == 0 & phi==1
			lambda = ((1-beta) + sqrt((beta-1)^2 + 8/v^2/T))/2;
		else
			lambda = ((1-beta) + phi*sqrt((beta-1)^2+4*alpha/h)) / 2;
		end
		y = (phi*exp(-q*T)*normcdf(phi*d1) + lambda*(phi*(Sx-K) - Ve)/Sx - phi)^2;
	end
end
